/*
 * Copyright (C) 2015 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * THIS FILE WAS GENERATED BY codergen. EDIT WITH CARE.
 */
package com.android.tools.idea.editors.gfxtrace.service.gfxapi;

import com.android.tools.rpclib.binary.Decoder;
import com.android.tools.rpclib.binary.Encoder;
import com.google.common.collect.ImmutableMap;
import org.jetbrains.annotations.NotNull;

import java.io.IOException;

public final class FramebufferAttachment {
  public static final FramebufferAttachment Color = new FramebufferAttachment(0, "Color");
  public static final int ColorValue = 0;
  public static final FramebufferAttachment Depth = new FramebufferAttachment(1, "Depth");
  public static final int DepthValue = 1;
  public static final FramebufferAttachment Stencil = new FramebufferAttachment(2, "Stencil");
  public static final int StencilValue = 2;

  private static final ImmutableMap<Integer, FramebufferAttachment> VALUES = ImmutableMap.<Integer, FramebufferAttachment>builder()
    .put(0, Color)
    .put(1, Depth)
    .put(2, Stencil)
    .build();

  private final int myValue;
  private final String myName;

  private FramebufferAttachment(int v, String n) {
    myValue = v;
    myName = n;
  }

  public int getValue() {
    return myValue;
  }

  public String getName() {
    return myName;
  }

  public void encode(@NotNull Encoder e) throws IOException {
    e.uint32(myValue);
  }

  public static FramebufferAttachment decode(@NotNull Decoder d) throws IOException {
    return findOrCreate(d.uint32());
  }

  public static FramebufferAttachment find(int value) {
    return VALUES.get(value);
  }

  public static FramebufferAttachment findOrCreate(int value) {
    FramebufferAttachment result = VALUES.get(value);
    return (result == null) ? new FramebufferAttachment(value, null) : result;
  }

  @Override
  public boolean equals(Object o) {
    if (this == o) return true;
    if (o == null || !(o instanceof FramebufferAttachment)) return false;
    return myValue == ((FramebufferAttachment)o).myValue;
  }

  @Override
  public int hashCode() {
    return myValue;
  }

  @Override
  public String toString() {
    return (myName == null) ? "FramebufferAttachment(" + myValue + ")" : myName;
  }
}
