/*
 * Copyright (C) 2015 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * THIS FILE WAS GENERATED BY codergen. EDIT WITH CARE.
 */
package com.android.tools.idea.editors.gfxtrace.service.memory;

import com.android.tools.rpclib.binary.Decoder;
import com.android.tools.rpclib.binary.Encoder;
import com.google.common.collect.ImmutableMap;
import org.jetbrains.annotations.NotNull;

import java.io.IOException;

public final class PoolID {
  public static final PoolID ApplicationPool = new PoolID(0, "ApplicationPool");
  public static final int ApplicationPoolValue = 0;

  private static final ImmutableMap<Integer, PoolID> VALUES = ImmutableMap.<Integer, PoolID>builder()
    .put(0, ApplicationPool)
    .build();

  private final int myValue;
  private final String myName;

  private PoolID(int v, String n) {
    myValue = v;
    myName = n;
  }

  public int getValue() {
    return myValue;
  }

  public String getName() {
    return myName;
  }

  public void encode(@NotNull Encoder e) throws IOException {
    e.uint32(myValue);
  }

  public static PoolID decode(@NotNull Decoder d) throws IOException {
    return findOrCreate(d.uint32());
  }

  public static PoolID find(int value) {
    return VALUES.get(value);
  }

  public static PoolID findOrCreate(int value) {
    PoolID result = VALUES.get(value);
    return (result == null) ? new PoolID(value, null) : result;
  }

  @Override
  public boolean equals(Object o) {
    if (this == o) return true;
    if (o == null || !(o instanceof PoolID)) return false;
    return myValue == ((PoolID)o).myValue;
  }

  @Override
  public int hashCode() {
    return myValue;
  }

  @Override
  public String toString() {
    return (myName == null) ? "PoolID(" + myValue + ")" : myName;
  }
}
